Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.vividsolutions.jts.geom
Class Polygon

    java.lang.Object
      com.vividsolutions.jts.geom.Geometry
          com.vividsolutions.jts.geom.Polygon

All Implemented Interfaces:
  java.lang.Cloneable, java.lang.Comparable, Polygonal, java.io.Serializable

public class Polygon
extends Geometry
implements Polygonal

Represents a linear polygon, which may include holes. The shell and holes of the polygon are represented by `LinearRing`s. In a valid polygon, holes may touch the shell or other holes at a single point. However, no sequence of touching holes may split the polygon into two pieces. The orientation of the rings in the polygon does not matter.

The shell and holes must conform to the assertions specified in the OpenGIS Simple Features Specification for SQL .

Version:
  1.7
See Also:
  Serialized Form

Field Summary
`protected LinearRing[]` | `holes` The interior boundaries, if any.
`protected LinearRing` | `shell` The exterior boundary, or `null` if this `Polygon` is empty.

Fields inherited from class com.vividsolutions.jts.geom.Geometry
`envelope, factory, SRID`

Constructor Summary
`Polygon(LinearRing shell, LinearRing[] holes, GeometryFactory factory)` Constructs a `Polygon` with the given exterior boundary and interior boundaries.
`Polygon(LinearRing shell, LinearRing[] holes, PrecisionModel precisionModel, int SRID)` Deprecated. Use GeometryFactory instead
`Polygon(LinearRing shell, PrecisionModel precisionModel, int SRID)` Deprecated. Use GeometryFactory instead

Method Summary
`void` | `apply(CoordinateFilter filter)` Performs an operation with or on this `Geometry`'s coordinates.
`void` | `apply(CoordinateSequenceFilter filter)` Performs an operation on the coordinates in this `Geometry`'s `CoordinateSequence`s.
`void` | `apply(GeometryComponentFilter filter)` Performs an operation with or on this Geometry and its component Geometry's.
`void` | `apply(GeometryFilter filter)` Performs an operation with or on this `Geometry` and its subelement `Geometry`s (if any).
`java.lang.Object` | `clone()` Creates and returns a full copy of this `Polygon` object.
`protected int` | `compareToSameClass(java.lang.Object o)` Returns whether this `Geometry` is greater than, equal to, or less than another `Geometry` having the same class.
`protected int` | `compareToSameClass(java.lang.Object o, CoordinateSequenceComparator comp)` Returns whether this `Geometry` is greater than, equal to, or less than another `Geometry` of the same class.
`protected Envelope` | `computeEnvelopeInternal()` Returns the minimum and maximum x and y values in this `Geometry` , or a null `Envelope` if this `Geometry` is empty.
`Geometry` | `convexHull()` Computes the smallest convex `Polygon` that contains all the points in the `Geometry`.
`boolean` | `equalsExact(Geometry other, double tolerance)` Returns true if the two `Geometry`s are exactly equal, up to a specified distance tolerance.
`double` | `getArea()` Returns the area of this `Polygon`
`Geometry` | `getBoundary()` Computes the boundary of this geometry
`int` | `getBoundaryDimension()` Returns the dimension of this `Geometry`s inherent boundary.
`Coordinate` | `getCoordinate()` Returns a vertex of this `Geometry` (usually, but not necessarily, the first one).
`Coordinate[]` | `getCoordinates()` Returns an array containing the values of all the vertices for this geometry.
`int` | `getDimension()` Returns the dimension of this geometry.
`LineString` | `getExteriorRing()`
`java.lang.String` | `getGeometryType()` Returns the name of this object's `com.vivid.jts.geom` interface.
`LineString` | `getInteriorRingN(int n)`
`double` | `getLength()` Returns the perimeter of this `Polygon`
`int` | `getNumInteriorRing()`
`int` | `getNumPoints()` Returns the count of this `Geometry`s vertices.
`boolean` | `isEmpty()` Returns whether or not the set of points in this `Geometry` is empty.
`boolean` | `isRectangle()`
`boolean` | `isSimple()` Tests if a valid polygon is simple.
`void` | `normalize()` Converts this `Geometry` to normal form (or canonical form ).
`Geometry` | `reverse()` Computes a new geometry which has all component coordinate sequences in reverse order (opposite orientation) to this one.

Methods inherited from class com.vividsolutions.jts.geom.Geometry
`buffer, buffer, buffer, checkNotGeometryCollection, compare, compareTo, compareTo, contains, coveredBy, covers, crosses, difference, disjoint, distance, equal, equals, equalsExact, geometryChanged, geometryChangedAction, getCentroid, getEnvelope, getEnvelopeInternal, getFactory, getGeometryN, getInteriorPoint, getNumGeometries, getPrecisionModel, getSRID, getUserData, hasNonEmptyElements, hasNullElements, intersection, intersects, isEquivalentClass, isGeometryCollection, isValid, isWithinDistance, overlaps, relate, relate, setSRID, setUserData, symDifference, toString, toText, touches, union, union, within`

Methods inherited from class java.lang.Object
`equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### shell

    protected LinearRing shell

  The exterior boundary, or `null` if this `Polygon` is empty.

### holes

    protected LinearRing[] holes

  The interior boundaries, if any. This instance var is never null. If there are no holes, the array is of zero length.

Constructor Detail

### Polygon

    public Polygon(LinearRing shell,
                   PrecisionModel precisionModel,
                   int SRID)

  Deprecated. Use GeometryFactory instead

  Constructs a `Polygon` with the given exterior boundary.

Parameters:
  `shell` - the outer boundary of the new `Polygon`, or `null` or an empty `LinearRing` if the empty geometry is to be created.
  `precisionModel` - the specification of the grid of allowable points for this `Polygon`
  `SRID` - the ID of the Spatial Reference System used by this `Polygon`

### Polygon

    public Polygon(LinearRing shell,
                   LinearRing[] holes,
                   PrecisionModel precisionModel,
                   int SRID)

  Deprecated. Use GeometryFactory instead

  Constructs a `Polygon` with the given exterior boundary and interior boundaries.

Parameters:
  `shell` - the outer boundary of the new `Polygon`, or `null` or an empty `LinearRing` if the empty geometry is to be created.
  `holes` - the inner boundaries of the new `Polygon` , or `null` or empty `LinearRing`s if the empty geometry is to be created.
  `precisionModel` - the specification of the grid of allowable points for this `Polygon`
  `SRID` - the ID of the Spatial Reference System used by this `Polygon`

### Polygon

    public Polygon(LinearRing shell,
                   LinearRing[] holes,
                   GeometryFactory factory)

  Constructs a `Polygon` with the given exterior boundary and interior boundaries.

Parameters:
  `shell` - the outer boundary of the new `Polygon`, or `null` or an empty `LinearRing` if the empty geometry is to be created.
  `holes` - the inner boundaries of the new `Polygon` , or `null` or empty `LinearRing`s if the empty geometry is to be created.

Method Detail

### getCoordinate

    public Coordinate getCoordinate()

  Description copied from class: `Geometry`
  Returns a vertex of this `Geometry` (usually, but not necessarily, the first one). The returned coordinate should not be assumed to be an actual Coordinate object used in the internal representation.

  Specified by:
    `getCoordinate` in class `Geometry`
  Returns:
    a `Coordinate` which is a vertex of this `Geometry`.

### getCoordinates

    public Coordinate[] getCoordinates()

  Description copied from class: `Geometry`
  Returns an array containing the values of all the vertices for this geometry. If the geometry is a composite, the array will contain all the vertices for the components, in the order in which the components occur in the geometry.

  In general, the array cannot be assumed to be the actual internal storage for the vertices. Thus modifying the array may not modify the geometry itself. Use the `CoordinateSequence.setOrdinate(int, int, double)` method (possibly on the components) to modify the underlying data. If the coordinates are modified, `Geometry.geometryChanged()` must be called afterwards.

  Specified by:
    `getCoordinates` in class `Geometry`
  Returns:
    the vertices of this `Geometry`
  See Also:
    `geometryChanged`, `CoordinateSequence.setOrdinate(int, int, double)`

### getNumPoints

    public int getNumPoints()

  Description copied from class: `Geometry`
  Returns the count of this `Geometry`s vertices. The `Geometry` s contained by composite `Geometry`s must be Geometry's; that is, they must implement `getNumPoints`

  Specified by:
    `getNumPoints` in class `Geometry`
  Returns:
    the number of vertices in this `Geometry`

### getDimension

    public int getDimension()

  Description copied from class: `Geometry`
  Returns the dimension of this geometry. The dimension of a geometry is is the topological dimension of its embedding in the 2-D Euclidean plane. In the JTS spatial model, dimension values are in the set {0,1,2}.

  Note that this is a different concept to the dimension of the vertex `Coordinate`s. The geometry dimension can never be greater than the coordinate dimension. For example, a 0-dimensional geometry (e.g. a Point) may have a coordinate dimension of 3 (X,Y,Z).

  Specified by:
    `getDimension` in class `Geometry`
  Returns:
    the topological dimension of this geometry.

### getBoundaryDimension

    public int getBoundaryDimension()

  Description copied from class: `Geometry`
  Returns the dimension of this `Geometry`s inherent boundary.

  Specified by:
    `getBoundaryDimension` in class `Geometry`
  Returns:
    the dimension of the boundary of the class implementing this interface, whether or not this object is the empty geometry. Returns `Dimension.FALSE` if the boundary is the empty geometry.

### isEmpty

    public boolean isEmpty()

  Description copied from class: `Geometry`
  Returns whether or not the set of points in this `Geometry` is empty.

  Specified by:
    `isEmpty` in class `Geometry`
  Returns:
    `true` if this `Geometry` equals the empty geometry

### isSimple

    public boolean isSimple()

  Tests if a valid polygon is simple. This method always returns true, since a valid polygon is always simple

  Overrides:
    `isSimple` in class `Geometry`
  Returns:
    `true`
  See Also:
    `Geometry.isValid()`

### isRectangle

    public boolean isRectangle()

  Overrides:
    `isRectangle` in class `Geometry`

### getExteriorRing

    public LineString getExteriorRing()

### getNumInteriorRing

    public int getNumInteriorRing()

### getInteriorRingN

    public LineString getInteriorRingN(int n)

### getGeometryType

    public java.lang.String getGeometryType()

  Description copied from class: `Geometry`
  Returns the name of this object's `com.vivid.jts.geom` interface.

  Specified by:
    `getGeometryType` in class `Geometry`
  Returns:
    the name of this `Geometry`s most specific `com.vividsolutions.jts.geom` interface

### getArea

    public double getArea()

  Returns the area of this `Polygon`

  Overrides:
    `getArea` in class `Geometry`
  Returns:
    the area of the polygon

### getLength

    public double getLength()

  Returns the perimeter of this `Polygon`

  Overrides:
    `getLength` in class `Geometry`
  Returns:
    the perimeter of the polygon

### getBoundary

    public Geometry getBoundary()

  Computes the boundary of this geometry

  Specified by:
    `getBoundary` in class `Geometry`
  Returns:
    a lineal geometry (which may be empty)
  See Also:
    `Geometry.getBoundary()`

### computeEnvelopeInternal

    protected Envelope computeEnvelopeInternal()

  Description copied from class: `Geometry`
  Returns the minimum and maximum x and y values in this `Geometry` , or a null `Envelope` if this `Geometry` is empty. Unlike `getEnvelopeInternal`, this method calculates the `Envelope` each time it is called; `getEnvelopeInternal` caches the result of this method.

  Specified by:
    `computeEnvelopeInternal` in class `Geometry`
  Returns:
    this `Geometry`s bounding box; if the `Geometry` is empty, `Envelope#isNull` will return `true`

### equalsExact

    public boolean equalsExact(Geometry other,
                               double tolerance)

  Description copied from class: `Geometry`
  Returns true if the two `Geometry`s are exactly equal, up to a specified distance tolerance. Two Geometries are exactly equal within a distance tolerance if and only if:
  - they have the same class
  - they have the same values for their vertices, within the given tolerance distance, in exactly the same order.
  If this and the other `Geometry`s are composites and any children are not `Geometry`s, returns `false`.

  Specified by:
    `equalsExact` in class `Geometry`
  Parameters:
    `other` - the `Geometry` with which to compare this `Geometry`
  Returns:
    `true` if this and the other `Geometry` are of the same class and have equal internal data.

### apply

    public void apply(CoordinateFilter filter)

  Description copied from class: `Geometry`
  Performs an operation with or on this `Geometry`'s coordinates. If this method modifies any coordinate values, `Geometry.geometryChanged()` must be called to update the geometry state. Note that you cannot use this method to modify this Geometry if its underlying CoordinateSequence's #get method returns a copy of the Coordinate, rather than the actual Coordinate stored (if it even stores Coordinate objects at all).

  Specified by:
    `apply` in class `Geometry`
  Parameters:
    `filter` - the filter to apply to this `Geometry`'s coordinates

### apply

    public void apply(CoordinateSequenceFilter filter)

  Description copied from class: `Geometry`
  Performs an operation on the coordinates in this `Geometry`'s `CoordinateSequence`s. If the filter reports that a coordinate value has been changed, `Geometry.geometryChanged()` will be called automatically.

  Specified by:
    `apply` in class `Geometry`
  Parameters:
    `filter` - the filter to apply

### apply

    public void apply(GeometryFilter filter)

  Description copied from class: `Geometry`
  Performs an operation with or on this `Geometry` and its subelement `Geometry`s (if any). Only GeometryCollections and subclasses have subelement Geometry's.

  Specified by:
    `apply` in class `Geometry`
  Parameters:
    `filter` - the filter to apply to this `Geometry` (and its children, if it is a `GeometryCollection`).

### apply

    public void apply(GeometryComponentFilter filter)

  Description copied from class: `Geometry`
  Performs an operation with or on this Geometry and its component Geometry's. Only GeometryCollections and Polygons have component Geometry's; for Polygons they are the LinearRings of the shell and holes.

  Specified by:
    `apply` in class `Geometry`
  Parameters:
    `filter` - the filter to apply to this `Geometry`.

### clone

    public java.lang.Object clone()

  Creates and returns a full copy of this `Polygon` object. (including all coordinates contained by it).

  Overrides:
    `clone` in class `Geometry`
  Returns:
    a clone of this instance

### convexHull

    public Geometry convexHull()

  Description copied from class: `Geometry`
  Computes the smallest convex `Polygon` that contains all the points in the `Geometry`. This obviously applies only to `Geometry` s which contain 3 or more points; the results for degenerate cases are specified as follows:

  Number of `Point`s in argument `Geometry` | `Geometry` class of result
  --- | ---
  0 | empty `GeometryCollection`
  1 | `Point`
  2 | `LineString`
  3 or more | `Polygon`

  Overrides:
    `convexHull` in class `Geometry`
  Returns:
    the minimum-area convex polygon containing this `Geometry`' s points

### normalize

    public void normalize()

  Description copied from class: `Geometry`
  Converts this `Geometry` to normal form (or canonical form ). Normal form is a unique representation for `Geometry` s. It can be used to test whether two `Geometry`s are equal in a way that is independent of the ordering of the coordinates within them. Normal form equality is a stronger condition than topological equality, but weaker than pointwise equality. The definitions for normal form use the standard lexicographical ordering for coordinates. "Sorted in order of coordinates" means the obvious extension of this ordering to sequences of coordinates.

  Specified by:
    `normalize` in class `Geometry`

### compareToSameClass

    protected int compareToSameClass(java.lang.Object o)

  Description copied from class: `Geometry`
  Returns whether this `Geometry` is greater than, equal to, or less than another `Geometry` having the same class.

  Specified by:
    `compareToSameClass` in class `Geometry`
  Parameters:
    `o` - a `Geometry` having the same class as this `Geometry`
  Returns:
    a positive number, 0, or a negative number, depending on whether this object is greater than, equal to, or less than `o`, as defined in "Normal Form For Geometry" in the JTS Technical Specifications

### compareToSameClass

    protected int compareToSameClass(java.lang.Object o,
                                     CoordinateSequenceComparator comp)

  Description copied from class: `Geometry`
  Returns whether this `Geometry` is greater than, equal to, or less than another `Geometry` of the same class. using the given `CoordinateSequenceComparator`.

  Specified by:
    `compareToSameClass` in class `Geometry`
  Parameters:
    `o` - a `Geometry` having the same class as this `Geometry`
    `comp` - a `CoordinateSequenceComparator`
  Returns:
    a positive number, 0, or a negative number, depending on whether this object is greater than, equal to, or less than `o`, as defined in "Normal Form For Geometry" in the JTS Technical Specifications

### reverse

    public Geometry reverse()

  Description copied from class: `Geometry`
  Computes a new geometry which has all component coordinate sequences in reverse order (opposite orientation) to this one.

  Specified by:
    `reverse` in class `Geometry`
  Returns:
    a reversed geometry

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD